Subject: Re: bug#79200: 31.0.50; Duplicated elements for '#<marker at' in buffer-undo-list

From: Gerd Möllmann <[email-masked]>
Date: Thu, 14 Aug 2025 12:34:12 +0200

Alan Mackenzie <[email-masked]> writes:

> Hello, Gerd.
>
> On Thu, Aug 14, 2025 at 11:53:40 +0200, Gerd Möllmann wrote:
>> Gerd Möllmann <[email-masked]> writes:
>
>> > Alan Mackenzie <[email-masked]> writes:
>
>> >> For what it's worth, I put next--marker-id into my Emacs, just as a
>> >> counter, nothing else.
>
>> >> In my emacs -Q, I do C-h v next--marker-id like you did, and a repeated
>> >> g to refresh it.  I get just 76 markers made at each iteration.
>
>> > Also interesting. With emacs -Q -nw, I get a delta of ca. 140, and in
>> > the GUI (mac) I get 270.
>
>> >> That makes your 472 look high indeed.  Might it possibly be there's a
>> >> bug with DEFVAR_INT somewhere, and that 472 = 8 * 59 has wrongly got the
>> >> 3 type bits in it, and is really just 59?  Just a suggestion.
>
>> > I think that's unlikely. There are a lot such defvar, and I think
>> > someone would have noticed such a bug.
>
>> Another interesting detail that I didn't remember are the values of
>> undo-limit and undo-strong-limit. I don't understand why they are so
>> high (160000/240000). With 1 undo/s, I could undo for 2 days.
>
>> Whatever, Maybe I'm overlooking something here. 
>
> I think those limits are numbers of bytes, not numbers of undo
> operations.  A single kill command in a big buffer could easily fill
> these numbers of bytes.

Ah, you're right. I had only read upto

  Don’t keep more than this much size of undo information.

and it later says

  The size is counted as the number of bytes occupied, 
  which includes both saved text and other data.